#include <iostream.h>
#include <string>
#include <cc++/socket.h>

extern int	errno;

/*
 *  Global variables
 */

static char *usageStr = " -t <tunnel port>";

int getline(int fd, string &str)
{
    char		c;
    int		nBytes;

    str = "";
    do
    {
	nBytes = read(fd, &c, 1);
	if ( nBytes != 1 )
	    return 1;

	if ( c != '\n' )
	    str += c;
    }  while ( c != '\n' );

    return 0;
}

main(int argc, char *argv[])
    {
    int			tunnelPortNum = 1199;
    char		*hostName = "localhost";
    int			rc;
    int			debug = 0;
    char		c;
    string		line;
    char		msg[128];
    extern char * optarg;

    /* Decode input args */
    while ( (c = getopt(argc, argv, "dh:t:")) != -1 )
	switch ( c )
	    {
	case 'd':
	    debug = 1;
	    break;
	    
	case 'h':
	    hostName = optarg;
	    break;
	    
	case 't' :
	    tunnelPortNum = atoi(optarg);
	    break;

	case '?' :
	    cerr << usageStr;
	    exit (1);
	    }

    /* Misc. checks */
    
    if ( tunnelPortNum == -1 )
    {
	cerr << argv[0] << " -t <port num> arguments missing\n";
	exit (1);
    }

    InetHostAddress hostadd(hostName);
    TCPStream tcp(hostadd, tunnelPortNum);
    if ( tcp.isConnected() )
	cout << "Connected to server" << endl;
    else
    {
	cerr << "Can't connect to server" << endl;
	exit(1);
    }
    for (;;)
    {
	tcp << "Hello world\n" << endl;
	// tcp >> c;
	// cout << "Received: " << c << endl;
	getline(tcp, line);
	cout << "Received: " << line << endl;
    }
    
    exit (0);
    }
